"""MSWord doc to text file converter for Document Library"""

from os import listdir, popen, remove, path
from Globals import package_home
from time import time

content_type = 'application/msword'

content_description = """Microsoft Word [
<a href="http://office.microsoft.com/downloads/9798/wd97vwr32.aspx" 
target="_blank">Download MS Word Viewer</a>]"""

wvConf_file = path.join(package_home(globals()), 'wvText.xml')

# Uses the wvWare, and assumes it is in the path
# Requires write access to /tmp

def convert(documentFile):
    """Convert MSWord data to raw text"""
    
    tmp_name = documentFile._writeToTempFile()
    text = popen('wvWare -x %s %s 2> /dev/null' % (wvConf_file, tmp_name)).read()
    remove(tmp_name)
    
    return text

# For increased speed, comment out line 400 of text.c in the wv source
