"""MSExcel doc to text file converter for Document Library
 kedai@kedai.com.my"""
 
 
from os import listdir, popen, remove, path
from Globals import package_home
from time import time
from sgmllib import SGMLParser
from string import join
 
content_type = ('application/ms-excel', 'application/vnd.ms-excel')
 
content_description = """Microsoft Excel [<a 
href="http://office.microsoft.com/downloads/2000/Xlview97.aspx" 
target="_blank">Download MS Excel Viewer</a>]"""
 
#uses xlHTML http://www.xlhtml.org
# Requires write access to /tmp

class _StripTagParser(SGMLParser):
  '''SGML Parser removing any tags and translating HTML entities.'''
 
  from htmlentitydefs import entitydefs
 
  data= None
 
  def handle_data(self,data):
    if self.data is None: self.data=[]
    self.data.append(data)
 
  def __str__(self):
    if self.data is None: return ''
    return join(self.data,'')

 
def convert(documentFile):
    """Convert MS-Excel data to raw text"""
 
    tmp_name = documentFile._writeToTempFile()
    text = popen('xlHtml -nc %s 2> /dev/null' % (tmp_name)).read()
    remove(tmp_name)
 
    p = _StripTagParser()
 
    try:
        p.feed(text)
        p.close()
        return str(p)
    except:
        return ''
